'''
base 0.2
Basic scanners for sagator.

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
    
'''

from avlib import *
import re,string

__all__=['finalscanner','regexp_scan','string_scan']

class finalscanner(ascanner):
  name=''
  S_OK='250'
  S_FAIL='451'
  def __init__(self,status='250'):
      self.status=status
  def scanstream(self,stream):
      if self.status==self.S_OK:
        return '',[]
      else:
        raise finalscanner,self.S_FAIL
  def scanfile(self,files,dirname=''):
      if self.status==self.S_OK:
        return '',[]
      else:
        raise finalscanner,self.S_FAIL

class regexp_scan(ascanner):
  '''
  Primitive regexp pattern scanner.
  
  Usage:
    string_scan({'VirName':'Regular_Expression_Pattern...',...})
  '''
  name='RegExpScanner'
  def __init__(self,regexps):
      self.regexps=regexps
  def scanstream(self,stream):
      for vname,reg in self.regexps.items():
        if re.search(reg,stream):
          return vname,['regexp: '+vname+' FOUND, '+reg+'\n']
      return '',[]

class string_scan(ascanner):
  '''
  Primitive string pattern scanner.
  
  Usage:
    string_scan({'VirName':'Pattern...',...})
  '''
  name='StringScanner'
  def __init__(self,strings):
      self.strings=strings
  def scanstream(self,stream):
      for vname,reg in self.strings.items():
        if string.find(stream,reg):
          return vname,['string: '+vname+' FOUND, '+reg+'\n']
      return '',[]
